package com.partisiablockchain.language.zkcircuitlowering.opt;

/*
 * Copyright (C) 2022 - 2023 Partisia Blockchain Foundation
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

import com.partisiablockchain.language.zkcircuit.ZkCircuit;
import com.partisiablockchain.language.zkcircuit.ZkCircuitGate;
import com.partisiablockchain.language.zkcircuit.ZkOperation;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.stream.Collectors;

/**
 * {@link ZkCircuit} Optimization pass collecting gates into streaks.
 *
 * <p>Optimizing pass over {@link ZkCircuit} for collecting gates into long streaks of similar
 * gates, which allows {@code ZkCircuitEngine} to run them in parallel.
 *
 * <p>Synergizes well with {@link ZkCircuitOptTreeBalance}, which rebalances the gate tree and
 * breaks dependencies.
 *
 * <p>Example:
 *
 * <pre>
 *   A = AND X Y
 *   B = OR A W
 *   C = OR X Y
 *   D = AND X W
 * </pre>
 *
 * <p>can be reordered to:
 *
 * <pre>
 *   A = AND X Y
 *   D = AND X W
 *   B = OR A W
 *   C = OR X Y
 * </pre>
 */
public final class ZkCircuitOptClustering {

  private ZkCircuitOptClustering() {}

  /**
   * Optimizes the given {@link ZkCircuit}.
   *
   * @param zkCircuit Circuit to optimize. Is not modified.
   * @return Newly optimized circuit.
   * @see ZkCircuitOptClustering for details on algorithm.
   */
  public static ZkCircuit optimizeZkCircuit(ZkCircuit zkCircuit) {

    final List<ZkCircuitGate> gates = zkCircuit.gateAddresses().map(zkCircuit::getGate).toList();

    final ZkCircuitOptimized outCircuit = new ZkCircuitOptimized(gates.size());
    outCircuit.setRoots(zkCircuit.getRoots());
    optimizeGates(gates, outCircuit);

    return outCircuit;
  }

  /**
   * Performs clustering optimization over the given list of gates.
   *
   * <p>Algorithm works over three kinds of worklists:
   *
   * <ul>
   *   <li>Input list of instructions to be optimized.
   *   <li>Output list of instructions for optimized "emitted" instructions.
   *   <li>{@code gatesWithEmittedDependencies}: Collection of instruction lists containing
   *       instructions that are yet to be emitted, but which have all of their dependencies
   *       emitted.
   * </ul>
   *
   * <p>Algorithm works by:
   *
   * <ul>
   *   <li>Iterating list of input instructions.
   *   <li>Moving an input instruction to {@code gatesWithEmittedDependencies} if all its
   *       instructions are emitted.
   *   <li>Emitting all instructions in the most preferred category. See {@link PREFERRED_ORDER}.
   *   <li>Emit all remaining instructions, once the entire circuit has had their dependencies
   *       satisfied.
   * </ul>
   *
   * @param inputGates Gates to optimize.
   * @param outCircuit Circuit to output to.
   */
  private static void optimizeGates(
      final List<ZkCircuitGate> inputGates, final ZkCircuitOptimized outCircuit) {

    // Create a stack of instructions that should be clustered.
    final List<ZkCircuitGate> inputGatesInReverseOrder = new ArrayList<ZkCircuitGate>(inputGates);
    Collections.reverse(inputGatesInReverseOrder);

    // Categorize gates
    final Map<Object, List<ZkCircuitGate>> gatesWithEmittedDependencies =
        PREFERRED_ORDER.stream()
            .collect(Collectors.toUnmodifiableMap(Function.identity(), x -> new ArrayList<>()));

    while (!inputGatesInReverseOrder.isEmpty()) {

      //  Track the current gate (gateIdx) and the lowest index (stopIdx) we should look in the
      //  current iteration.
      //  The stopIdx allows the system to collect more instructions from
      //  a list of instructions with a lot of repeated subsections, similar to
      //  that generated by list iteration.
      int gateIdx = inputGatesInReverseOrder.size() - 1;
      int stopIdx = 0;

      // Determine gates that have their requirements satisfied
      while (stopIdx <= gateIdx) {
        final ZkCircuitGate gate = inputGatesInReverseOrder.get(gateIdx);
        final boolean allDependenciesEmitted =
            ZkOperationAddressUsage.usedAddresses(gate.operation()).stream()
                .allMatch(outCircuit::hasGate);
        if (allDependenciesEmitted) {
          inputGatesInReverseOrder.remove(gateIdx);
          // Categorize
          gatesWithEmittedDependencies.get(categorizeOperation(gate.operation())).add(gate);
          stopIdx = Math.max(0, gateIdx - 10);
        }
        gateIdx -= 1;
      }

      // Determine what set of gates should be emitted.
      List<ZkCircuitGate> gatesToEmit = null;
      for (final Object category : PREFERRED_ORDER) {
        gatesToEmit = gatesWithEmittedDependencies.get(category);
        if (!gatesToEmit.isEmpty()) {
          break;
        }
      }

      // Complain if there is no gates to emit.
      if (gatesToEmit.isEmpty()) {
        throw new RuntimeException("No gates to emit!");
      }

      // Emit gates and bookkeep.
      outCircuit.addAll(gatesToEmit);
      gatesToEmit.clear();
    }

    // Emit any remaining instructions that have not yet been needed
    // These are required by the circuit roots.
    for (final List<ZkCircuitGate> instructionsForOperation :
        gatesWithEmittedDependencies.values()) {
      outCircuit.addAll(instructionsForOperation);
    }
  }

  /**
   * The preferred output order of instruction categorizations.
   *
   * <p>Preference order is mostly based on how much clusters improve parallelism, and how expensive
   * different operations are.
   *
   * <p>This list is not guarenteed to contain all operands. Those operands that are not explicitly
   * covered will be covered by the {@code misc} category.
   */
  private static final List<String> PREFERRED_ORDER =
      List.of(
          "nullary",
          "misc",
          ZkOperation.BinaryOp.BITWISE_XOR.toString(),
          ZkOperation.BinaryOp.BITWISE_OR.toString(),
          ZkOperation.BinaryOp.BITWISE_AND.toString(),
          ZkOperation.BinaryOp.ARITH_ADD_WRAPPING.toString(),
          ZkOperation.BinaryOp.CMP_LESS_THAN_OR_EQUALS_SIGNED.toString(),
          ZkOperation.BinaryOp.CMP_EQUALS.toString(),
          ZkOperation.BinaryOp.ARITH_MULTIPLY_SIGNED.toString(),
          "select");

  /**
   * Categorizes each {@link ZkCircuitGate} into one of the categorizes specified in {@link
   * PREFERRED_ORDER}.
   *
   * @param operation Operation to categorize
   * @return Category
   */
  static String categorizeOperation(final ZkOperation operation) {
    if (operation instanceof ZkOperation.Binary op
        && PREFERRED_ORDER.contains(op.operation().toString())) {
      return op.operation().toString();
    } else if (operation instanceof ZkOperation.Select) {
      return "select";
    } else if (operation instanceof ZkOperation.Constant) {
      return "nullary";
    } else if (operation instanceof ZkOperation.Load) {
      return "nullary";
    }
    return "misc";
  }
}
